/* $Id: infornography.c 3 2007-07-09 07:59:45Z romain $ */

#include <stdio.h>
#include <stdlib.h>

#include "iterator.h"

int
main(int argc, char *argv[])
{
  int i;
  int error;

  Iterator iterators_head = NULL;
  Iterator iterators_tail = NULL;

  if (argc < 2) {
    fprintf(stderr, "usage: %s iterator... command\n", argv[0]);
    exit(EXIT_FAILURE);
  }

	if (!(iterator_initialize())) {
		exit(EXIT_FAILURE);
	}
  
  for (i=1;i<argc - 1;i++) {
    Iterator new;
    if ((new = iterator_new(argv[i]))) {
      if (!iterators_head) {
        iterators_head = new;
      } else {
        iterator_insert_after(iterators_tail, new);
      }
      iterators_tail = new;
    } else {
      fprintf(stderr, "Unable to create iterator\n");
    }
  }
  
  iterator_iterate(iterators_head, argv[argc - 1], &error);
  
  /* Free iterators */

  while ((iterators_head = iterator_delete(iterators_head)));
  iterators_tail = iterators_head;
  
	iterator_finalize();
  exit(error);
}
